--- channels/chan_alsa.c	6 Jun 2005 22:12:18 -0000	1.44
+++ channels/chan_alsa.c	12 Jun 2005 16:54:17 -0000
@@ -887,9 +887,10 @@
 {
 	int tmparg = 2;
 	int res = RESULT_SUCCESS;
+	int i;
+	
 	if (argc < 2)
 		return RESULT_SHOWUSAGE;
-	ast_mutex_lock(&alsalock);
 	if (!alsa.owner) {
 		ast_cli(fd, "No one is calling us\n");
 		res = RESULT_FAILURE;
@@ -897,24 +898,39 @@
 		struct ast_frame f = { AST_FRAME_TEXT, 0 };
 		char text2send[256] = "";
 		text2send[0] = '\0';
-		while(tmparg < argc) {
-			strncat(text2send, argv[tmparg++], sizeof(text2send) - strlen(text2send) - 1);
-			strncat(text2send, " ", sizeof(text2send) - strlen(text2send) - 1);
-		}
-		f.data = text2send;
-		f.datalen = strlen(text2send) + 1;
+		
 		grab_owner();
 		if (alsa.owner) {
-			ast_queue_frame(alsa.owner, &f);
 			f.frametype = AST_FRAME_CONTROL;
 			f.subclass = AST_CONTROL_ANSWER;
 			f.data = NULL;
 			f.datalen = 0;
+			ast_mutex_lock(&alsalock);
 			ast_queue_frame(alsa.owner, &f);
 			ast_mutex_unlock(&alsa.owner->lock);
+			ast_mutex_unlock(&alsalock);
+		}
+		
+		while(tmparg < argc) {
+			strncat(text2send, argv[tmparg++], sizeof(text2send) - strlen(text2send) - 1);
+			strncat(text2send, " ", sizeof(text2send) - strlen(text2send) - 1);
+		}
+		for (i=0;i < strlen(text2send);i++) {
+			f.data = &text2send[i];
+			f.datalen = 1;
+			f.frametype = AST_FRAME_TEXT;
+			f.subclass = 0;
+			grab_owner();
+			if (alsa.owner) {
+				ast_mutex_lock(&alsalock);
+				ast_queue_frame(alsa.owner, &f);
+				ast_mutex_unlock(&alsa.owner->lock);
+				ast_mutex_unlock(&alsalock);
+				usleep(25000);
+			}
 		}
+
 	}
-	ast_mutex_unlock(&alsalock);
 	return res;
 }
 
